	@library	soundlib

;************************************************
;						*
;		SOUND LIBRARY 0.5		*
;		    MADE BY			*
;		 MARKUS KLISICS			*
;						*
; The lib allows you to play songs. They are	*
; made in a specific format shown in the doc.	*
;************************************************

Send	MACRO			; Sends a Byte through red and white
 move.b  	\1,($60000E)
 or.w		#%110000000000,($60000E)
 nop
 nop
	ENDM

Wait	MACRO			; Waits \1 loops
 move.l		d6,-(a7)
 move.l		\1,d6
\waitloop:
 dbra		d6,\waitloop
 move.l		(a7)+,d6
	ENDM

Sound	MACRO			; \1=Freq  \2=Lenght
 movem.l	d6-d7,-(a7)
 move.l		\1,d6
 move.l		\2,d7
 bsr		Play
 movem.l	(a7)+,d6-d7
	ENDM

GetKey MACRO
  move.w  \1,($600018)
  nop
  nop
  nop
  nop
  move.b  ($60001B),d0
 ENDM

Pause	MACRO
 movem.l	d6-d7,-(a7)
 move.l		\1,d7
 mulu		#16500,d7
 clr.l		d6
\pauseloop:
 addq.l		#1,d6
 cmp.l		d7,d6
 blt		\pauseloop
 movem.l	(a7)+,d6-d7
	ENDM

;************** Start of Fargo Library **************

 label 		play_song
 movem.l	d0-d7/a0-a1,-(a7)	; save some regs
 move.w		#$2700,sr		; disable interrupts
loop:
 GetKey		#$FDFF			; test if [q] was pressed
 btst		#3,d0
 beq		Exit			; if true -> exit
 lea		tones(PC),a1		; freq lookup table
 clr.l		d0
 clr.l		d1
 clr.l		d2
 clr.l		d3
 move.b		(a0)+,d0		; tone
 cmp.b		#255,d0			; is this the end
 beq		Exit			; if true -> exit
 move.b		(a0)+,d1		; lenght
 move.l		d0,d2			; copy d0 to d2
 mulu		#4,d0			; mulu by 4 cause the table is in words
 adda.l		d0,a1			; place a1 at the right address
 move.w		(a1)+,d0		; copy freq to d0
 move.w		(a1),d3			; copy lenght to d3
 cmp.b		#99,d2			; if d2=99 -> it's a pause
 bne		skippause		; not true -> skip the pause
 move.l		#16,d3
 divu.w		d1,d3			; calc the right lenght
 Pause		d3			; pause d3
 bra		loop
skippause:
 divu.w		d1,d3			; calc the right lenght
 Sound		d0,d3			; make a sound
 bra		loop

Exit:
 move.w		#$2000,sr		; enable interrupts
 movem.l	(a7)+,d0-d7/a0-a1	; restore regs
 rts					; quit

Play:
 Send		#100			; sends a byte with the size 100
 Wait		d6
 dbra		d7,Play			; do it d7 times
 rts

;******************** Tone table *******************


tones:		dc.w	5188,128,4876,128,4600,128,4353,144,4131,144,3867,144,3635,160,3429,176,3245,176,3079,192,2895,208,2730,224	; c-h #2
		dc.w	2556,240,2403,256,2267,272,2145,272,2035,304,1906,320,1791,336,1690,352,1599,368,1517,400,1426,416,1345,448	; c-h #3
		dc.w	1260,464,1184,512,1117,544,1057,560,1003,608,939,640,883,672,833,720,788,752,748,800,703,848,663,896		; c-h #4
		dc.w	621,960,583,1024,550,1088,521,1136,494,1200,463,1280,435,1376,410,1456,388,1520,368,1616,346,1712,327,1808,306,1936	; c-c#6 #5


;*************** End of Fargo Library ***************


	reloc_open
	reloc_close
	end